<template>
    <div class="payment-checkbox-list">
        <div class="header-cells">
            <div class="checkbox">&nbsp;</div>
            <div class="shop">МЕСТО ПОКУПКИ</div>
            <div class="date">ДАТА</div>
            <div class="amount">СУММА</div>
            <div class="pay">К ОПЛАТЕ</div>
            <div class="overdue"></div>
        </div>

        <div v-for="(sale, index) in saleList" :key="index" class="ui-checkbox">
            <div class="info-table">
                <div class="checkbox"><ui-checkbox v-model="sale.selected" :disabled="sale.isOverdue" @change="updateSum"></ui-checkbox></div>
                <div class="shop">{{sale.shop.name}}</div>
                <div class="date">{{sale.date|date}}</div>
                <div class="amount">{{sale.amount}}</div>
                <div class="pay">{{sale.amount - sale.paid_amount}}</div>
                <div class="overdue" @click="toggleTooltip(index)">
                    <SVGIcon xlink="hint-20" :fill="$theme.colors.statusRed" view-box="0 0 20 20" v-if="sale.isOverdue"></SVGIcon>
                </div>
                <transition name="fade" :duration="75">
                    <div class="tooltip" v-if="sale.tooltip">
                        <span class="close">
                            <SVGIcon xlink="close-45" viewBox="0 0 45 45" :fill="$theme.colors.gray" class="close"
                                     @click.native="toggleTooltip(index)"></SVGIcon>
                        </span>
                        <span class="text">
                            <b>Просроченный платеж.</b> Вы не можете отменить оплату.
                        </span>
                    </div>
                </transition>
            </div>
        </div>
    </div>
</template>

<script>
    import PosScheduleMixin from '../mixins/schedule';
    import SVGIcon from '@/components/SVGIcon'
    import dayjs from 'dayjs';
	export default {
        name: 'component-pos-payment-checkbox-list',
        mixins: [
        	PosScheduleMixin,
        ],
        components: {
			SVGIcon
        },

        computed: {
			saleList () {
                return this.sales.concat(this.currentPay.sales);
            },
		},

        data () {
        	return {
        		tooltip: false,
                sales: [],
            }
        },

        filters: {
        	date(date) {
        		return dayjs(date).format('DD.MM.YYYY');
            }
        },

        created () {
            this.$POS.schedule.filter((schedule) => {
				return schedule.isPaid === false && schedule.isOverdue === true
			}).forEach((schedule) => {
				schedule.sales.filter((sale) => {
					return sale.paid_amount < sale.amount;
				}).forEach((sale) => {
					sale.isOverdue = schedule.isOverdue;
					sale.date = schedule.date;
					sale.tooltip = false;
					this.sales.push(sale);
                })
			});

			this.$emit('set-sales', this.saleList);
        },

        methods: {
        	updateSum () {
				this.$emit('set-sales', this.saleList);
            },

            toggleTooltip(index) {
        		this.$set(this.sales, index, {...this.sales[index], tooltip: !this.sales[index].tooltip});
        		this.sales.forEach((sale, idx) => {
        			if(index !== idx && sale.tooltip) {
        				this.$set(this.sales, idx, {...sale, tooltip: false});
                    }
                });


            }
        }
	};
</script>

<style scoped>

</style>
